> For the complete documentation index, see [llms.txt](https://docs.kubemq.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kubemq.io/configuration/connectors/kubemq-bridges/targets/query.md).

# Query

KubeMQ Bridges Query target provides an RPC query sender for processing sources requests.

## Prerequisites

The following are required to run the query target connector:

* kubemq cluster
* kubemq-bridges deployment

## Configuration

Query target connector configuration properties:

| Properties Key   | Required | Description                                      | Example                                              |
| ---------------- | -------- | ------------------------------------------------ | ---------------------------------------------------- |
| address          | yes      | kubemq server address (gRPC interface)           | kubemq-cluster-a-grpc.kubemq.svc.cluster.local:50000 |
| client\_id       | no       | set client id                                    | "client\_id"                                         |
| auth\_token      | no       | set authentication token                         | JWT token                                            |
| default\_channel | no       | set default channel to send request              |                                                      |
| timeout\_seconds | no       | sets query request default timeout (600 seconds) |                                                      |

Example:

```yaml
bindings:
  - name:  query-binding 
    properties: 
      log_level: error
      retry_attempts: 3
      retry_delay_milliseconds: 1000
      retry_max_jitter_milliseconds: 100
      retry_delay_type: "back-off"
      rate_per_second: 100
    sources:
    .....
    targets:
      kind: target.query # Sources kind
      name: 3-clusters-targets # targets name 
      connections: # Array of connections settings per each target kind
        - address: "kubemq-cluster-a-grpc.kubemq.svc.cluster.local:50000"
          client_id: "cluster-a-query-connection"
          auth_token: ""
          channel: "query"
          group: ""
        - address: "kubemq-cluster-b-grpc.kubemq.svc.cluster.local:50000"
          client_id: "cluster-b-query-connection"
          auth_token: ""
          channel: "query"
          group: ""
        - address: "kubemq-cluster-c-grpc.kubemq.svc.cluster.local:50000"
          client_id: "cluster-c-query-connection"
          auth_token: ""
          channel: "query"
          group: ""
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kubemq.io/configuration/connectors/kubemq-bridges/targets/query.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
